import db from '../db.js';

class Post {
    constructor(ID, posterID, URI, visibility, createdAt, updatedAt, hash) {
        this.ID = ID;
        this.posterID = posterID;
        this.URI = URI;
        this.visibility = visibility;
        this.createdAt = createdAt;
        this.updatedAt = updatedAt;
        this.hash = hash;
    }
    // TODO: When a duplicate is posted (Identical hash), set visibility to Restricted and flag the post (and the "dupe") for mod review.
    // Some sort of frontent UI to let them allow the post as a false duplicate, or delete it as a true duplicate.
    // Maybe even prompt the uploader with an "Are you sure? We found a post that looks like this one." message, to filter out some before mod intervention.

    // Also, allow mods to hashban posts, so that they can't be posted again.
    // Seperate table with the banned hashes, reason for the ban, and the action to take when upload is attempted.
    // Some should flag the user, some may want to autoban the user, some may just want to refuse the post without penalty.
    // Use the above system to inform users that the post failed. Some way to do this before bothering to create a record in DB.

    getVisibilityAsString() {
        switch (this.visibility) {
            case 0:
                return 'Public'; // Posts with this visibility are always visible.
            case 1:
                return 'Visible to users'; // Posts with this visibility are only visible to logged in users.
            case 2:
                return 'Unlisted'; // Posts with this visibility are only visible by direct link.
            case 3:
                return 'Restricted'; // Posts with this visibility are only visible to the poster, and users allowed to view all posts. (Moderators)
            default:
                return 'Unknown'; // This should never happen. If it does, treat it like Restricted. Maybe automatically set them to Restricted?
        }
    }
}

export default Post;